/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.ProductoServicio;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderProductoServicio;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("busquedaProductoServicioControllerMX")
@Scope("prototype")
public class BusquedaProductoServicioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ProductoServicio> plwProductoServicio;
    private MyListbox PSList;
    private Paging pagingPS;
    private Textbox txtNombre;

    public MyListbox getPSList() {
        return PSList;
    }

    public void setPSList(MyListbox PSList) {
        this.PSList = PSList;
    }

    public Paging getPagingPS() {
        return pagingPS;
    }

    public void setPagingPS(Paging pagingPS) {
        this.pagingPS = pagingPS;
    }

    public PagedListWrapper<ProductoServicio> getPlwProductoServicio() {
        return plwProductoServicio;
    }

    public void setPlwProductoServicio(PagedListWrapper<ProductoServicio> plwProductoServicio) {
        this.plwProductoServicio = plwProductoServicio;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verProductoServicio(new ProductoServicio());

    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        PSList.setItemRenderer(new RenderProductoServicio());
        PSList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ProductoServicio ps = (ProductoServicio) PSList.getSelected();
                verProductoServicio(ps);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verProductoServicio(ProductoServicio ps) {
        if (ps == null) {
            return;
        }

        Map args = new HashMap();
        args.put("ps", ps);
        args.put("PSList", PSList);

        openWindow("/gui/catalogos/editarProductoServicio.zul",
                Labels.getLabel("indexController.mniProductoServicio.label"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ProductoServicio> claseServicioBusqueda =
                new HibernateSearchObject<ProductoServicio>(ProductoServicio.class, pagingPS.getPageSize());

        claseServicioBusqueda.addFilterLike("descproductoservicio", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
        claseServicioBusqueda.addSortAsc("descproductoservicio");
        claseServicioBusqueda.addFilterNotEqual("productoservicioId", -1);

        plwProductoServicio.init(claseServicioBusqueda, PSList, pagingPS);
        if (PSList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaPeriodoVacacionalController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
                
            }
        }
    }
}
